function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React, { useEffect, useState } from 'react';
import useNode from '../useNode';
import '../../styles/row2column.less';
import { Input, Spin, Table, Form } from 'antd';
import { ColumnCell } from '../compareTable';
import AddList from './addList';
import FillingColumn from './fillingColumn';
import Preview from './preview';
import { IconFont } from '@zgfe/business-lib';
import ColumnFilterPanel from './filterPanel';
import _ from 'lodash';
export var classPrefix = 'flow-row2column-config';
var FlowRow2Column = function FlowRow2Column(_ref) {
  var node = _ref.node;
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState = useState(node.getData().label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    targetColumn = _useState4[0],
    setTargetColumn = _useState4[1];
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    fillingColumn = _useState6[0],
    setFillingColumn = _useState6[1];
  var _useState7 = useState([]),
    _useState8 = _slicedToArray(_useState7, 2),
    addList = _useState8[0],
    setAddList = _useState8[1];
  var _useState9 = useState([]),
    _useState0 = _slicedToArray(_useState9, 2),
    selectList = _useState0[0],
    setSelectList = _useState0[1];
  // 初始化数据
  useEffect(function () {
    var data = node.getData();
    setTargetColumn(data.targetColumn);
    setFillingColumn(data.fillingColumn);
    setAddList(data.addList);
    setSelectList(data.columnList);
  }, []);
  useEffect(function () {
    node.updateData({
      status: targetColumn && fillingColumn && addList.length && selectList.length && actName ? 'success' : 'failed',
      targetColumn: targetColumn,
      fillingColumn: fillingColumn,
      addList: addList,
      label: actName,
      columnList: selectList
    });
  }, [targetColumn, fillingColumn, addList, selectList, actName]);
  function onChangeTargetColumn(_keys, selectRows) {
    setTargetColumn(selectRows[0]);
  }
  if (loading) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix
    }, /*#__PURE__*/React.createElement(Spin, {
      className: "".concat(classPrefix, "-loading")
    }));
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement(Form, null, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0"))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-box")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-column")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u884C\u8F6C\u5217\u914D\u7F6E")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-bottom")
  }, /*#__PURE__*/React.createElement(Table, {
    columns: [{
      title: '字段名称',
      dataIndex: 'name',
      render: function render(v, row) {
        return /*#__PURE__*/React.createElement(ColumnCell, {
          column: row
        });
      },
      filterDropdown: function filterDropdown(props) {
        return /*#__PURE__*/React.createElement(ColumnFilterPanel, {
          filterProps: props,
          columnList: columnList
        });
      },
      onFilter: function onFilter(val, record) {
        return new RegExp(val).test(record.name);
      }
    }],
    rowKey: "name",
    rowSelection: {
      type: 'radio',
      selectedRowKeys: targetColumn ? [targetColumn === null || targetColumn === void 0 ? void 0 : targetColumn.name] : undefined,
      getCheckboxProps: function getCheckboxProps(record) {
        return {
          disabled: record.name === (fillingColumn === null || fillingColumn === void 0 ? void 0 : fillingColumn.name)
        };
      },
      onChange: onChangeTargetColumn
    },
    dataSource: columnList,
    pagination: false
  }))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-column center")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-bottom")
  }, /*#__PURE__*/React.createElement(FillingColumn, {
    targetColumn: targetColumn,
    defaultValue: fillingColumn,
    columnList: columnList,
    onChange: setFillingColumn
  }), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u65B0\u589E\u5B57\u6BB5"), /*#__PURE__*/React.createElement("span", {
    className: "tip"
  }, /*#__PURE__*/React.createElement(IconFont, {
    type: "tishiicon"
  }), "\u4E2D\u6587\u884C\u8F6C\u5217\u65F6\uFF0C\u9700\u8981\u5229\u7528\u6620\u5C04\u503C\u8FDB\u884C\u5904\u7406")), /*#__PURE__*/React.createElement(AddList, {
    onChange: setAddList,
    defaultValue: addList
  }))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-column right_")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-bottom")
  }, /*#__PURE__*/React.createElement(Preview, {
    targetColumn: targetColumn,
    fillingColumn: fillingColumn,
    addList: addList,
    originColumnList: columnList,
    defaultValue: selectList,
    onChange: setSelectList
  })))));
};
export default FlowRow2Column;